#!/usr/bin/env python

import sys, getopt, os.path

##########################################
##
##	default parameters for refineAll
##
##########################################
Usage	=	"Usage: "+sys.argv[0]+" <template-ortcen.dat> <first-n.log> <last-n.log> [--phase=<num>] [--low=<low res in pixel>] [--high=<high res in pixel>] [--imgsize=<n>] [--out=<filename>]\n"
elimicmd	= "eliminateort"
low			= ""
high		= ""
phase		= ""
imgsize		= ""
out			= ""
##
#########################################

if len(sys.argv) < 4:
	print Usage
	sys.exit(1)
elif len(sys.argv) > 4:
	try:
		optlist, junks = getopt.getopt(sys.argv[4:], 'l:h:s:p:', ['low=','high=','imgsize=','phase=','out='])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	for o, a in optlist:
		if o in ("-l", "--low"):
			low=a
		if o in ("-h", "--high"):
			high=a
		if o in ("-s", "--imgsize"):
			imgsize=a
		if o in ("-p", "--phase"):
			phase=a
		if o in ("--out",):
			out=a
			
#############################################################
# Execute eliminateort
#############################################################
command = elimicmd+" "+sys.argv[1]+" "+sys.argv[2]+" "+sys.argv[3]
try:
	cmd=os.popen(command,'w') 
	cmd.write("%s\n%s\n" % (phase,imgsize))
	cmd.write("%s %s\n" % (low,high))
	cmd.close()
except KeyboardInterrupt:
	sys.exit(3)
except :
	print sys.argv[0]+": error in running command \""+command+"\""
	sys.exit(4)		
else:
	if os.path.exists("definedort.dat"):
		if out: 
			os.rename("definedort.dat",out)
		else:
			out="definedort.dat"
		print sys.argv[0]+": eliminate the initial orientation and center parameters, saved to file "+out+"\n" 
	else:
		print sys.argv[0]+": error in running command \""+command+"\", no result is generated"
		sys.exit(5)	
