#!/usr/bin/env python

import sys, getopt, os.path

##########################################
##
##	default parameters for refineAll
##
##########################################
Usage	=	"Usage: "+sys.argv[0]+" <input-ortcen.dat> <output-ortcen.dat> [--low=<low res in pixel>] [--high=<high res in pixel>] [--cycle=<n>] [--thresh=<num>] [--step=<num>] [--cpu=<n>]\n"
refinecmd	= "globalRefine"
low			= "3"
high		= "36"
cycle		= ""
thresh		= "1"
cpu			= "1"
step		= "2.0"	#degree
##
#########################################

if len(sys.argv) < 3:
	print Usage
	sys.exit(1)
elif len(sys.argv) > 3:
	try:
		optlist, junks = getopt.getopt(sys.argv[3:], 'l:h:c:s:t:', ['low=','high=','cpu=','cycle=','thresh=','step='])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	for o, a in optlist:
		if o in ("-l", "--low"):
			low=a
		if o in ("-h", "--high"):
			high=a
		if o in ("-c", "--cpu"):
			cpu=a
		if o in ("-t", "--thresh"):
			thresh=a
		if o in ("--cycle",):
			cycle=a
		if o in ("-s", "--step"):
			step=a
			
#############################################################
# Execute globalRefine
#############################################################
if os.path.exists(sys.argv[2]): os.remove(sys.argv[2])
command = refinecmd+" "+sys.argv[1]+" "+sys.argv[2]
try:
	cmd=os.popen(command,'w') 
	cmd.write("%s %s\n%s\n%s\n" % (low,high,cycle,thresh))
	cmd.write("%s\n%s\n" % (step, cpu))
	cmd.close()
except KeyboardInterrupt:
	sys.exit(3)
except :
	print sys.argv[0]+": error in running command \""+command+"\""
	sys.exit(4)		
else:
	print sys.argv[0]+": globalRefine the initial orientation and center parameters, saved to file \""+sys.argv[2]+"\"\n" 
