#!/usr/bin/env python

import sys, os, getopt

Usage = "Usage: %s <map> [--inort=<ortfile>] [--out=<filename>] [--vert=<0-11>] [--ori5f=<0-4>] [--from2forigin] [--mask=<radius>] [--imask=<radius>] [--invert] [--pad=<newsize>] [--step=<stepsize(indegree)>] [--MRCcenter] [--mode=<<1-6>] [--wave] [--random] [--verbose] [--cpu=<n>]" % ( sys.argv[0] )

cpu		=	1
verbose	=	0
cmd		=	""

if len(sys.argv)<2:
	print Usage
	sys.exit(1)
else: 	
	try:
		optlist, junks = getopt.getopt(sys.argv[2:], 'vc:', ['inort=','out=','vert=','ori5f=','from2forigin','mask=','imask=','invert','pad=','step=','MRCcenter','mode=','wave','random','verbose','cpu='])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	
	cmd="projecticos %s " % (sys.argv[1])
	for o, a in optlist:
		if o in ("-v", "--verbose"):
			cmd += " verbose"
			verbose = 1
		elif o in ("-c", "--cpu"):
			cpu = int( a )
		elif o in ("--inort",):
			cmd += " inort=" % a
		elif o in ("--out",):
			cmd += " out=%s" % a 
		elif o in ("--vert",):
			cmd += " vert=%s" % a 
		elif o in ("--ori5f",):
			cmd += " ori5f=%s" % a 
		elif o in ("--from2forigin",):
			cmd += " from2forigin"
		elif o in ("--mask",):
			cmd += " mask=%s" % a 
		elif o in ("--imask",):
			cmd += " imask=%s" % a 
		elif o in ("--invert",):
			cmd += " invert" 
		elif o in ("--pad",):
			cmd += " pad=%s" % a 
		elif o in ("--step",):
			cmd += " step=%s" % a 
		elif o in ("--MRCcenter",):
			cmd += " MRCcenter"  
		elif o in ("--mode",):
			cmd += " mode=%s" % a 
		elif o in ("--wave",):
			cmd += " wave"  
		elif o in ("--random",):
			cmd += " random"  
	
	import tempfile
	tempfile.tempdir = os.getcwd()
	jobfile=tempfile.mktemp("-projecticos.runpar")
	jobfp=open(jobfile,"w")
	for c in range(cpu):
		jobfp.write("%s frac=%d/%d\n" % (cmd, c, cpu))
	jobfp.close()
	runpar_cmd="runpar proc=%d,%d file=%s" % (cpu,cpu,jobfile)
	if verbose:
		print runpar_cmd
		print cmd
	try:
		os.system(runpar_cmd)
	except: raise RuntimeError("running command \"%s\"" % (runpar_cmd))
	os.remove(jobfile)

